<?php

namespace Treewec\Admin;

/**
 * Test class for FormTester.
 * Generated by PHPUnit on 2012-07-04 at 11:11:38.
 * @group admin_form
 */
class FormTesterTest extends \PHPUnit_Framework_TestCase {

    /** @var \Treewec\Admin\Third\FormProcessor */
    private $formProcessor;
    /** @var FormTester */
    private $formTester;

    protected function setUp() {
        $this->formProcessor = new Third\FormProcessor(false);
        $this->formTester = new FormTester($this->formProcessor);
    }

    public function testTestBoolean() {        
        // valid: '1', '0'
        $this->formTester->testBoolean('1');
        $this->assertSuccess();
        $invalid = array(true, false, array());
        foreach ($invalid as $value) {
            $this->formTester->testBoolean($value);
            $this->assertFailure();
        }
    }

    public function testTestClassConstant() {
        $this->formTester->testClassConstant('\Treewec\FileSystem\FileType', \Treewec\FileSystem\FileType::FILE);
        $this->assertSuccess();
        $this->formTester->testClassConstant('\Treewec\FileSystem\FileType', array());
        $this->assertFailure();
    }

    public function testTestString() {
        $this->formTester->testString('hello', array('min' => 2, 'max' => 5));
        $this->assertSuccess();
        $this->formTester->testString('hello', array('min' => 2, 'max' => 3));
        $this->assertFailure();
    }

    public function testTestNumber() {
        $this->formTester->testNumber('11', array('min' => 2, 'max' => 11));
        $this->assertSuccess();
        $this->formTester->testNumber('a2', array('min' => 2, 'max' => 3));
        $this->assertFailure();
    }

    public function testTestFilename() {
        $this->formTester->testFilename('hello');
        $this->assertSuccess();
        $this->formTester->testFilename('hello world? ');
        $this->assertFailure();
    }

    public function testTestNewFilename() {
        $this->formTester->testNewFilename('hello', TEMP_FILEDIR, true);
        $this->assertSuccess();
        $this->formTester->testNewFilename('existing', TEMP_FILEDIR, true);
        $this->assertFailure();
    }

    public function testTestExistingDirectory() {
        $this->formTester->testExistingDirectory('existing', TEMP_FILEDIR);
        $this->assertSuccess();
        $this->formTester->testExistingDirectory('unexisting', TEMP_FILEDIR);
        $this->assertFailure();
    }

    private function assertSuccess() {
        parent::assertTrue($this->formProcessor->is_valid());
    }

    private function assertFailure() {
        parent::assertFalse($this->formProcessor->is_valid());
        $this->formProcessor->reset_errors();
    }

}

?>
